<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewershipsTypeViewershipDistributorType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfViewershipsTypeViewershipDistributorType extends AbstractStructArrayBase
{
    /**
     * The DistributorType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgDistributorType[]
     */
    public $DistributorType;
    /**
     * Constructor method for ArrayOfViewershipsTypeViewershipDistributorType
     * @uses DgArrayOfViewershipsTypeViewershipDistributorType::setDistributorType()
     * @param \dgsoft\StructType\DgDistributorType[] $distributorType
     */
    public function __construct(array $distributorType = array())
    {
        $this
            ->setDistributorType($distributorType);
    }
    /**
     * Get DistributorType value
     * @return \dgsoft\StructType\DgDistributorType[]|null
     */
    public function getDistributorType()
    {
        return $this->DistributorType;
    }
    /**
     * Set DistributorType value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgDistributorType[] $distributorType
     * @return \dgsoft\ArrayType\DgArrayOfViewershipsTypeViewershipDistributorType
     */
    public function setDistributorType(array $distributorType = array())
    {
        foreach ($distributorType as $arrayOfViewershipsTypeViewershipDistributorTypeDistributorTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewershipsTypeViewershipDistributorTypeDistributorTypeItem instanceof \dgsoft\StructType\DgDistributorType) {
                throw new \InvalidArgumentException(sprintf('The DistributorType property can only contain items of \dgsoft\StructType\DgDistributorType, "%s" given', is_object($arrayOfViewershipsTypeViewershipDistributorTypeDistributorTypeItem) ? get_class($arrayOfViewershipsTypeViewershipDistributorTypeDistributorTypeItem) : gettype($arrayOfViewershipsTypeViewershipDistributorTypeDistributorTypeItem)), __LINE__);
            }
        }
        $this->DistributorType = $distributorType;
        return $this;
    }
    /**
     * Add item to DistributorType value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgDistributorType $item
     * @return \dgsoft\ArrayType\DgArrayOfViewershipsTypeViewershipDistributorType
     */
    public function addToDistributorType(\dgsoft\StructType\DgDistributorType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgDistributorType) {
            throw new \InvalidArgumentException(sprintf('The DistributorType property can only contain items of \dgsoft\StructType\DgDistributorType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DistributorType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgDistributorType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgDistributorType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgDistributorType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgDistributorType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgDistributorType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistributorType
     */
    public function getAttributeName()
    {
        return 'DistributorType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfViewershipsTypeViewershipDistributorType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
